/*
 * jQuery Verical Timeline Plugin 1.0.0
 * http://www.klemmkeil.de/jquery-timeline-plugin
 *
 * Copyright 2014, Rainer Mohr
 * http://www.klemmkeil.de
 *
 * Licensed under the MIT license:
 * http://www.opensource.org/licenses/MIT
 */

(function ( $ ) {
	$.fn.timeline = function( options ) {	
		var defaults = {
	        onecolumnmaxwidth: 300, // this is the minimum width, where it switches to one column
			timelineitems:".timelineitem", // the class of the timeline items
			timelinebubbles:".timelinebubble", // the class of the bubbles for the timeline
			timelinegrouping:".timelinegrouping", // the class of the grouping content per timelineitem
			timelinecolor:"rgb(206,236,248)", // the color of the middle vertical line and the bubble-borders
			timelinebubblecolor:"rgb(206,236,248)", // the background-color of the bubbles
			timelinegroupingcolor:"rgb(100,100,100)", // the background-color of the grouping headers
			timelinegroupingwidth:80, // the width of the grouping headers in pxels
			timelinewidth:3 // the thickness of the vertical line and the bubble-borders
	    };
	    var options = $.extend(defaults, options);
	    var me = $(this);
		var lefttop = 0;
		var righttop = 0;
		var bubblebottom = 0;
		var heightofitem;
		var onecolumnmaxwidth = options.onecolumnmaxwidth; 
		var groupingheader = "";
		var timelinewidth = $(this).width();
		var vertlinestartfromleft = timelinewidth/2-(options.timelinewidth/2)+1;
		var timelineitemwidth = (timelinewidth-80)/2
		var timelinesingleitemwidth = timelinewidth-80;
		
		if (timelineitemwidth < onecolumnmaxwidth) vertlinestartfromleft = 40;
		// add a vertical line
		if ($("#verticaltimeline").length == 0) $(this).prepend('<div id="verticaltimeline"></div>');
		$("#verticaltimeline").css("left",vertlinestartfromleft+"px").css("height","100%").css("width",options.timelinewidth+"px").css("position","absolute").css("top","0").css("background-color",options.timelinecolor);	
		// remove all grouping boxes (necessary for resizing)
		$('.groupingbox').remove();

		$(this).children(options.timelineitems).each(function( index ) {
			$(this).removeClass("arrow_box_right").removeClass("arrow_box_left");
			$(this).css("position","absolute").css("border-radius","8px");
			var grouping = $(this).children(options.timelinegrouping);
			if (groupingheader != grouping.text() && grouping.text().length > 0) {
				var leftoffset = timelinewidth/2-(options.timelinegroupingwidth/2)-4;
				if (timelineitemwidth < onecolumnmaxwidth) leftoffset = 7;
				grouping.css("display","none");
				grouping.css("top",(Math.max(righttop,lefttop)) ).css("left",leftoffset+"px");
				$(grouping).clone().appendTo(me).addClass("groupingbox").removeClass(options.timelinegrouping).css("display","block").css("width",options.timelinegroupingwidth+"px").css("position","absolute").css("text-align","center").css("background-color",options.timelinegroupingcolor).css("padding","5px").css("border-radius","8px");
				var newtopoffset = Math.max(righttop,lefttop) + 40;
				righttop = newtopoffset;
				lefttop = newtopoffset;						
			} else {
				grouping.css("display","none");
			}
			if (grouping.text().length > 0) groupingheader = grouping.text();

			var bubble = $(this).children(options.timelinebubbles);
			$(bubble).css("border-color",options.timelinecolor).css("border-width",options.timelinewidth+"px").css("border-style","solid");
			var lineheight = 60-($(bubble).outerWidth() - $(bubble).innerWidth());
			$(bubble).css("width","60px").css("height","60px").css("border-radius","50%").css("text-align","center").css("line-height",lineheight + "px").css("position","absolute").css("box-sizing","border-box").css("background-color",options.timelinebubblecolor);

			if (timelineitemwidth < onecolumnmaxwidth) {
				$(this).css("width",timelinesingleitemwidth+"px");
				heightofitem = $(this).height();
				if (righttop < bubblebottom) righttop = bubblebottom;
				$(this).css("left","80px").css("top",righttop+"px");
				$(bubble).css("left","-70px").css("top","6px");
				bubblebottom = righttop + 80;
				righttop = righttop + heightofitem + 20;
				$(this).addClass("arrow_box_right");
			} else {
				$(this).css("width",timelineitemwidth+"px");
				heightofitem = $(this).height();
				if (lefttop <= righttop) {
					// put it on the left side
					if (lefttop < bubblebottom) lefttop = bubblebottom;					
					$(this).css("left","0px").css("top",lefttop+"px");					
					$(bubble).css("left",(timelineitemwidth+10)+"px").css("top","8px");					
					bubblebottom = lefttop + 80;
					lefttop = lefttop + heightofitem + 20;
					$(this).addClass("arrow_box_left");
				} else {
					// put it o the right
					if (righttop < bubblebottom) righttop = bubblebottom;
					$(this).css("left",(timelineitemwidth+80)+"px").css("top",righttop+"px");
					$(bubble).css("left","-70px").css("top","6px");
					bubblebottom = righttop + 80;
					righttop = righttop + heightofitem + 20;
					$(this).addClass("arrow_box_right");
				}
			}				
		});

		$(me).css("height",Math.max(righttop,lefttop)+"px" ).css("position","relative");
	};
}( jQuery ));